#> pk_mo_pa:core/place/start
# @context: as the placed painting at @s

# Tag the current painting
tag @s add pk_mo_pa.current.painting.component
tag @s add pk.mo_pa.painting.component

# Set params from painting data
# - rx: Used to dynamically set the Rotation[0] of item_display entities depending on the facing data of the painting
data modify storage pk.common:data Params set value {rx:"0"}
execute store result score $facing pk.temp run data get storage pk.common:data Temp.Entity.facing
execute if score $facing pk.temp matches 0 run data modify storage pk.common:data Params.rx set value "180"
execute if score $facing pk.temp matches 1 run data modify storage pk.common:data Params.rx set value "-90"
execute if score $facing pk.temp matches 3 run data modify storage pk.common:data Params.rx set value "90"

# Summon the controller and make it mount the painting
summon marker ~ ~ ~ {Tags:["pk.mo_pa.painting.component","pk.mo_pa.painting.controller","pk.mo_pa.current.painting.component"]}
ride @e[type=marker,tag=pk.mo_pa.painting.controller,tag=pk.mo_pa.current.painting.component,distance=..0.1,limit=1] mount @s

# Place the right painting type depending on the current painting format
execute if data storage pk.common:data Temp{PaintingType:"1x1"} run function pk_mo_pa:core/place/1x1/random
execute if data storage pk.common:data Temp{PaintingType:"1x2"} run function pk_mo_pa:core/place/1x2/random
execute if data storage pk.common:data Temp{PaintingType:"2x1"} run function pk_mo_pa:core/place/2x1/random
execute if data storage pk.common:data Temp{PaintingType:"2x2"} run function pk_mo_pa:core/place/2x2/random

# Set id to the painting components
scoreboard players add $pk.mo_pa.painting.next pk.mo_pa.component.id 1
scoreboard players operation @e[type=#pk_mo_pa:painting/components,tag=pk.mo_pa.current.painting.component,distance=..0.1] pk.mo_pa.component.id = $pk.mo_pa.painting.next pk.mo_pa.component.id

# Remove the current tag from all components
tag @e[type=#pk_mo_pa:painting/components,tag=pk.mo_pa.current.painting.component,distance=..0.1] remove pk.mo_pa.current.painting.component